summary | shortlog | log | commit | commitdiff | tree
raw | patch | inline | side by side (parent: e433705)
raw | patch | inline | side by side (parent: e433705)
author | Junio C Hamano <junkio@cox.net> | |
Fri, 11 Nov 2005 03:30:23 +0000 (19:30 -0800) | ||
committer | Junio C Hamano <junkio@cox.net> | |
Sat, 12 Nov 2005 05:18:18 +0000 (21:18 -0800) |
If two sides added the same path completely different thing, it is
easier to see the merge pivoting on /dev/null. So check the size of
the common section we have found, and empty it if it is too small.
Signed-off-by: Junio C Hamano <junkio@cox.net>
easier to see the merge pivoting on /dev/null. So check the size of
the common section we have found, and empty it if it is too small.
Signed-off-by: Junio C Hamano <junkio@cox.net>
git-merge-one-file.sh | patch | blob | history |
diff --git a/git-merge-one-file.sh b/git-merge-one-file.sh
index d9ee4581504984e4337a70433f82c411bb5a9c02..b08597de29afc6bc1aaddf7b817bc122cd517b04 100755 (executable)
--- a/git-merge-one-file.sh
+++ b/git-merge-one-file.sh
# This extracts OUR file in $orig, and uses git-apply to
# remove lines that are unique to ours.
orig=`git-unpack-file $2`
+ sz0=`wc -c <"$orig"`
diff -u -La/$orig -Lb/$orig $orig $src2 | git-apply --no-add
+ sz1=`wc -c <"$orig"`
+
+ # If we do not have enough common material, it is not
+ # worth trying two-file merge using common subsections.
+ expr "$sz0" \< "$sz1" \* 2 >/dev/null || : >$orig
;;
*)
echo "Auto-merging $4."